'''
Author: error: error: git config user.name & please set dead value or install git && error: git config user.email & please set dead value or install git & please set dead value or install git
Date: 2024-04-18 15:19:44
LastEditors: error: error: git config user.name & please set dead value or install git && error: git config user.email & please set dead value or install git & please set dead value or install git
LastEditTime: 2024-04-18 20:38:08
FilePath: /bench_tools/bench_tool/ni-cdaq.py
Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
'''
import argparse
from utils.ConfigManagers import DeviceManager
from utils.IOManagers import NI_Managers

USAGE = """
1. List device and boards, type and name
2. Add and reserve a new device
3. Read/write AI, AO, DI, DO, CI, CO
Commands:
  python3 ni-cdaq.py --find-test
  python3 ni-cdaq.py --add-reserve
  python3 ni-cdaq.py --type do --src cDAQ9189-1Mod1/port0/line25 --set True
  python3 ni-cdaq.py --type di --src cDAQ9189-1Mod1/port0/line0
"""

def main():
    parser = argparse.ArgumentParser(description="Manage NI cDAQ devices", usage=USAGE)
    parser.add_argument("--type", choices=["ai", "ao", "di", "do", "ci", "co"])
    parser.add_argument("--subtype", choices=["voltage", "current", "freq", "duty_cycle"])
    parser.add_argument("--src")
    parser.add_argument("--set", action='store_true', help="Set digital output to True")
    parser.add_argument("-v", type=float, default=0)
    parser.add_argument("-f", type=int, default=1000)
    parser.add_argument("-d", type=float, default=0.5)
    parser.add_argument("--find-test", action="store_true", help="List devices and boards")
    parser.add_argument("--add-reserve", action="store_true", help="Add and reserve a new device")
    args = parser.parse_args()

    with NI_Managers() as ni:
        if args.type == "ai":
            print(ni.ai_read(args.src, io_subtype=args.subtype))
        elif args.type == "ao":
            ni.ao_write(args.src, args.v, io_subtype=args.subtype)
        elif args.type == "di":
            print(ni.di_read(args.src))
        elif args.type == "do":
            ni.do_write(args.src, args.set)
        elif args.type == "ci":
            print(ni.ci_read(args.src, io_subtype=args.subtype))
        elif args.type == "co":
            ni.co_write(args.src, args.f, args.d)
        elif args.find_test:
            ni.find_test_devices()
        elif args.add_reserve:
            ni.add_reserve_devices(DeviceManager().BENCH_DICT.get("cdaq_ips"))
        else:
            print("No valid operation provided.")

if __name__ == "__main__":
    main()
