"""
Author: chong.ma
Date: 2023-12-04 18:00:12
LastEditTime: 2024-04-09 19:49:45
FilePath: /root/bench_tool/bench_tool/usb-pwm.py
Description:

"""

import argparse
import re
import subprocess
import time

from utils.ConfigManagers import DeviceManager
from utils.PWMManagers import PWMManager

USAGE = """
1. 设置PWM输出，读取PWM输入，其中0~3为输入，4~7为输出
python3 usb-pwm.py --type CO --src /dev/usb_pwm@04 -f 1000 -d 50
python3 usb-pwm.py --type CI --src /dev/usb_pwm@01
"""

if __name__ == "__main__":
    dm = DeviceManager()
    parser = argparse.ArgumentParser()

    parser.add_argument("--type", required=False, type=str, choices=["CI", "CO"])
    parser.add_argument("--src", required=False, type=str, help="ch 0~3 input 4~7 output. eg /dev/usb_pwm@04")
    parser.add_argument("-f", required=False, type=int, help="freq 0~65535Hz")
    parser.add_argument("-d", required=False, type=float, help="duty 0~100.00")
    args = parser.parse_args()

    if dm.BENCH_DICT.get("pwm_type") == "usb-pwm":
        if args.type == "CO":
            src = args.src.split("@")
            with PWMManager(args.src, src[0], 000000, src[1], "output") as pwm:
                pwm.set_pwm(args.f, args.d)
        elif args.type == "CI":
            src = args.src.split("@")
            with PWMManager(args.src, src[0], 000000, src[1], "input") as pwm:
                print(pwm.read_pwm())
