'''
Author: chong.ma
Date: 2023-11-24 14:30:02
LastEditTime: 2023-11-24 20:09:04
FilePath: /root/bench_tool/utils/Drivers.py
Description: 

'''
import subprocess
import can
import struct



class Candriver:
    def __init__(self):
        self.bus = can.interface.Bus(channel="can039", bustype='socketcan')

    def __enter__(self):
        print("enter")
        status = subprocess.getoutput(f"ifconfig {self.channel}")
        if "UP" not in status:
            print(f"you should set {self.channel} up")
            self.bus.shutdown()
            exit(1)
        return self
    
    def __exit__(self, exc_type, exc_val, exc_tb):
        print("exit")
        self.bus.shutdown()
        pass
        
    def send_frame(self, can_id, data, extended = True, remote = False,):
        msg = can.Message(arbitration_id=can_id, data=data, is_extended_id=extended, is_remote_frame=remote)
        self.bus.send(msg)

    def receive_frame(self):
        msg = self.bus.recv()
        can_id = msg.arbitration_id
        data = msg.data
        extended = msg.is_extended_id
        remote = msg.is_remote_frame
        return can_id, data, extended, remote
    
    def parse_frame(self, can_id, data):
        # parse CAN frame data into meaningful information
        # ...
        # return parsed_info
        pass
    
    def compose_frame(self, parsed_info):
        # compose parsed information into CAN frame data
        # ...
        # return can_id, data, extended, remote   
        pass

if __name__ == "__main__":
    res_can = Candriver()
    res_can.send_frame(0x1FFFFFFF, [0x00, 0x00, 0x00, 0x00, 0x64, 0x00, 0x00, 0xF0])
    # res_can.send_frame(0x000, [], remote = True)
    print(res_can.receive_frame())