'''
Author: chong.ma
Date: 2023-12-04 20:28:35
LastEditTime: 2024-01-05 20:26:59
FilePath: /root/bench_tool/bench_tool/utils/SerialManagers.py
Description: 

'''
import telnetlib
import subprocess
import sys, os
from .Logger import get_logger
from pathlib import Path
from utils.Utils import Utils

sys.path.append(os.path.dirname(os.path.dirname(__file__)))
BENCH_TOOL_DIR = Path(__file__).resolve().parents[1]
logger = get_logger("BenchManagers")

class USB_Serials:
    def __init__(self, serials):
        self.serials = serials
        pass
    
    def __enter__(self, **kwargs):
        print("Entering the context")
        return self  # 返回一个用于上下文的对象

    def __exit__(self, exc_type, exc_value, traceback):
        print("Exiting the context")
        
    def fix_serial(self):
        print("Executing FIX serial...")
        cmd = ['bash', f'{BENCH_TOOL_DIR}/scripts/fix_serial.sh'] + [f"{key}={val}" for key, val in self.serials.items()]
        Utils.execute_command(cmd)
        # # 调用Shell脚本，并将字典元素作为命令行参数传递
        # subprocess.run(["./scripts/fix_serial.sh"] + )
                
class NET_Serials:
    def __init__(self, serials):
        self.serials = serials
        pass
    
    def __enter__(self, **kwargs):
        print("Entering the context")
        return self  # 返回一个用于上下文的对象

    def __exit__(self, exc_type, exc_value, traceback):
        print("Exiting the context")
  
    def check_serial(self, host = "192.168.1.5", timeout = 1):
        for key, val in self.serials.items():
            try:
                tn = telnetlib.Telnet(host, val, timeout)        
                tn.write(b'\r\n')
                response = tn.read_until(b'\r\n', timeout)
                tn.close()
                if response:
                    print(f"{key.ljust(15)} --> port: {val.ljust(22)}: success")
                else:
                    print(f"{key.ljust(15)} --> port: {val.ljust(22)}: failed")  
            except Exception as e:
                print(e)
